// engine.cpp -> engine stuff

#include "./engine.h"

//BITMAP *tiles[128];
BITMAP *main_char[8];
BITMAP *chicken[8];
BITMAP *e1[8];
BITMAP *e2[8];
BITMAP *e3[8];
BITMAP *bg;
int map[5][1024][1024];
int w, h, layer;

int px,py=0;

void fps_timer()
{
    lfps=fps;
    fps=0;
}
END_OF_FUNCTION(fps_timer);

void game_timer()
{
    game_time++;
}
END_OF_FUNCTION(game_timer);

void start_timers()
{
    install_int_ex(fps_timer, BPS_TO_TIMER(1));
    install_int_ex(game_timer, BPS_TO_TIMER(60));
}

void stop_timers()
{
    remove_int(fps_timer);
    remove_int(game_timer);
}


void draw_screen(int tlx, int tly)
{
    // start at map[0][tly][tlx] and keep going till the screen is full
    clear_bitmap(buffer);
    blit((BITMAP *)dat[BACKDROP].dat, buffer, 0, 0, 0, 0, 320, 200);
    for(int y=tly; y-tly<6; y++)
    {
        for(int x=tlx; x-tlx<10; x++)
        {
            switch(map[0][tlx][tly])
            {
                case 0:
                    draw_sprite(buffer, chicken[0], y*32, y*32);
                    break;
                case 1:
                    draw_sprite(buffer, e1[0], x*32, y*32);
                    break;
                case 2:
                    draw_sprite(buffer, e2[0], x*32, y*32);
                    break;
                case 3:
                    draw_sprite(buffer, e3[0], x*32, y*32);
                    break;
                case 4:
                    draw_sprite(buffer, secret_b, x*32, y*32);
                    break;
            }
        }
    }
    draw_sprite(buffer, main_char[0], (px-tlx)*32, (py-tly)*32);
    rectfill(buffer, 0, SCREEN_H-8, SCREEN_W, SCREEN_H, makecol(0,0,0));
    textprintf(buffer, font, 0, SCREEN_H-text_height(font), makecol(255,255,255), "x: %i y: %i", tlx, tly);
}

void load_map(const char *filename)
{
    //int w, int h, int layer =0;
    /*PACKFILE *map_file=pack_fopen(filename, "r");
    
    w=pack_igetw(map_file);
    h=pack_igetw(map_file);
    layer=pack_igetw(map_file);
    
    for(int z=0; z<layer; z++)
        for(int y=0; y<h; y++)
            for(int x=0; x<w; x++)
                map[z][y][x]=pack_igetw(map_file);
        
    pack_fclose(map_file);*/
    w=128;
    h=128;
    layer=1;
    srand(time(NULL));
    int i,j=0;
    for(i=0; i<128; i++)
    {
        for(j=0; j<128; j++);
        {
            map[0][i][j]=rand()%4;
        }
    }
    map[0][rand()%128][rand()%128]=4;
}


void load_tiles()
{
    // load main_char, chicken, and the three "enemy" animations.
    main_char[0]=create_bitmap(32, 32);
    chicken[0]=create_bitmap(32, 32);
    e1[0]=create_bitmap(32, 32);
    e2[0]=create_bitmap(32, 32);
    e3[0]=create_bitmap(32, 32);
    blit((BITMAP *)dat[CHAR_TILESET].dat, main_char[0], 0, 3*32, 0, 0, 32, 32);
    blit((BITMAP *)dat[CHAR_TILESET].dat, chicken[0], 3*32, 3*32, 0, 0, 32, 32);
    blit((BITMAP *)dat[CHAR_TILESET].dat, e1[0], 5*32, 3*32, 0, 0, 32, 32);
    blit((BITMAP *)dat[CHAR_TILESET].dat, e2[0], 7*32, 3*32, 0, 0, 32, 32);
    blit((BITMAP *)dat[CHAR_TILESET].dat, e3[0], 9*32, 3*32, 0, 0, 32, 32);
}


void test_blit()
{
    clear_bitmap(screen);
    blit((BITMAP *)dat[BACKDROP].dat, screen, 0, 0, 0, 0, 320, 200);
    textprintf(screen, font, 0, 0, makecol(0,0,0), "I am sorry, but I couldn't finish");
    textprintf(screen, font, 0, 10, makecol(0,0,0), "the game in time because some ");
    textprintf(screen, font, 0, 20, makecol(0,0,0), "stuff came up on Sunday.");
    textprintf(screen, font, 0, 40, makecol(0,0,0), " I will finish and release");
    textprintf(screen, font, 0, 50, makecol(0,0,0), "the game later on. Sorry :'(");
    while(!key[KEY_ESC]);
}


void main_loop()
{
    stop_midi();
    play_midi((MIDI *)dat[TITLE_SONG].dat, 1);
    bool done=false;
    while(!done)
    {
        while(game_time>0)
        {
            //logics
            if(key[KEY_UP])
                py++;
            if(key[KEY_DOWN])
                py--;
            if(key[KEY_LEFT])
                px--;
            if(key[KEY_RIGHT])
                px++;
            if(key[KEY_ESC])
                done=true;
            game_time--;
        }
        while(game_time<0)
            ;
        draw_screen(px, py);
        blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
        fps++;
    }
}
