// engine.h -> engine.cpp headers

#include <allegro.h>
#include <time.h>
#include <stdio.h>
#include "./data.h"

#ifndef __ENGINE_H
#define __ENGINE_H

extern DATAFILE *dat;
extern BITMAP *buffer;

//extern BITMAP *tiles[128];
extern BITMAP *main_char[8];
extern BITMAP *chicken[8];
extern BITMAP *e1[8];
extern BITMAP *e2[8];
extern BITMAP *e3[8];
extern BITMAP *secret_b;
extern BITMAP *bg;
extern int map[5][1024][1024];
extern int w, h, layer;

extern volatile int fps;
extern volatile int lfps;
extern volatile int game_time;

void fps_timer();
void game_timer();
void start_timers();
void stop_timers();

void draw_screen(int tlx, int tly);
void load_map(const char *filename);

void load_tiles();

void test_blit();

void main_loop();
#endif
